#include "validation.h"

using namespace std;

int main(int argc, char** argv) {
	// Set up the input and answer streams.
	std::ifstream in(argv[1]);
	// std::ifstream ans(argv[2]); // Only for custom checker.
	OutputValidator v(argc, argv);

	v.set_WA_handler([&]() {
		// When there is a WA, try to terminate the teams code gracefully by sending the final line.
		cout << "I quacked the code!" << endl;
		fclose(stdout);
	});

	string line;
	while(getline(in, line)) {
		cout << line << endl;
		if(line == "I quacked the code!") {
			// The OutputValidator will read team output eof.
			return 0;
		}
		string expected = line.back() == '?' ? "Quack!" : "*Nod*";

		v.test_string(expected);
		v.newline();
	}

	// No quack the code found!
	assert(false);
}
