#include "validation.h"

using namespace std;

void pad(string& s) {
	reverse(s.begin(), s.end());
	while(s.size() < 20) s.push_back('0');
	reverse(s.begin(), s.end());
}

int main(int argc, char** argv) {
	// Set up the input and answer streams.
	std::ifstream in(argv[1]);
	std::ifstream ans(argv[2]); // Only for custom checker.
	OutputValidator v(argc, argv);

	int n;
	in >> n;
	vector<string> S(n);
	for(auto& s : S) in >> s, pad(s);

	string tans;
	ans >> tans;

	string uans = v.test_string(tans);
	v.newline();
	if(tans == "possible") {
		vector<string> uS(n);
		for(auto& s : uS) {
			s = v.read_string("s", 1, 19);
			if(s.empty() || (s[0] == '0' && s.size() != 1U))
				v.WA("Read empty or zero-padded line in contestant answer.");
			pad(s);
			v.newline();
		}

		// Check that the sequence is sorted.
		for(int i = 0; i + 1 < n; ++i)
			if(uS[i].compare(uS[i + 1]) > 0) v.WA("Contestant sequence is not sorted.");

		// Check that the sequences match.
		for(int i = 0; i < n; ++i) {
			for(int j = 0; j < 20; ++j) {
				if(uS[i][j] == '9') uS[i][j] = '6';
				if(S[i][j] == '9') S[i][j] = '6';
			}
			if(S[i] != uS[i]) v.WA("Contestant output does not match input.");
		}
	}
}
