import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.*;
import java.util.*;

public class erikfaster {
	public static void main(String[] args) throws IOException {
//		IO io = new IO(System.in);
		Scanner io = new Scanner(System.in);
		
		int n = io.nextInt();

		P[] points = new P[n];

		for (int i = 0; i < n; i++) {
			int x = io.nextInt();
			int y = io.nextInt();
			points[i] = new P(x, y, i);
		}

		int[][] directions = new int[][] { { 1, 0 }, { 1, 1 }, { 0, 1 }, { -1, 1 }, { -1, 0 }, { -1, -1 }, { 0, -1 },
				{ 1, -1 } };

		HashMap<Integer, ArrayList<P>>[] lines = new HashMap[8];
		for (int i = 0; i < directions.length; i++) {
			lines[i] = new HashMap<Integer, ArrayList<P>>();
			int dx = directions[i][0];
			int dy = directions[i][1];
			
			for (int j = 0; j < n; j++) {
				P p = points[j];
				int offset = dy * p.x - dx * p.y;
				if (!lines[i].containsKey(offset)) {
					ArrayList<P> list = new ArrayList<P>();
					list.add(p);
					lines[i].put(offset, list);
				} else {
					((ArrayList<P>) lines[i].get(offset)).add(p);
				}
			}
			
			for (int x : lines[i].keySet()) {
				Collections.sort(lines[i].get(x), (p1, p2) -> (dx*p1.x + dy*p1.y) - (dx*p2.x + dy*p2.y));
			}
		}
		
		
		long res = 0;
		for (int i = 0; i < n; i++) {
			int[] count = new int[n];
			count[i] = 1;
			for (HashMap<Integer, ArrayList<P>> line : lines) {
				int[] count2 = new int[n];
				for (ArrayList<P> list : line.values()) {
					if(list.size() == 1) continue;
					int acc = 0;
					for (P p : list) {
						count2[p.ind] += acc;
						acc += count[p.ind];
					}
				}
				count = count2;
			}
			res += count[i];
		}
		

//		io.println(res);
		System.out.println(res);
		io.close();
	}
	
	static class P {
		int x, y, ind;
		
		P(int _x, int _y, int _i) {
			x = _x;
			y = _y;
			ind = _i;
		}
	}

	static class IO extends PrintWriter {
		static BufferedReader r;
		static StringTokenizer t;

		public IO(InputStream i) {
			super(new BufferedOutputStream(System.out));
			r = new BufferedReader(new InputStreamReader(i));
			t = new StringTokenizer("");
		}

		public String next() throws IOException {
			while (!t.hasMoreTokens()) {
				t = new StringTokenizer(r.readLine());
			}
			return t.nextToken();
		}

		public int nextInt() throws IOException {
			return Integer.parseInt(next());
		}

		public long nextLong() throws IOException {
			return Long.parseLong(next());
		}

		public double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}
	}
}
