#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int N;
ll A[10005];

ll minimize(ll x) {
	if (x == 0) return 0;
	return 10 * minimize(x / 10) + ((x % 10) == 9 ? 6 : (x % 10));
}

vector<ll> collect(ll x) {
	vector<ll> L;
	ll f = 1;
	while (x != 0) {
		if (x % 10 == 6) L.push_back(3 * f);
		x /= 10; f *= 10;
	}
	return L;
}

ll leastAbove(vector<ll>& L, int i, ll goal) {
	if (i == L.size()) return 0;
	if (L[i] < goal) return L[i] + leastAbove(L, i + 1, goal - L[i]);
	else {
		ll x = leastAbove(L, i + 1, goal);
		return (x >= goal ? x : L[i]);
	}
}

int main() {
	cin >> N;
	for (int i = 0; i < N; i++) cin >> A[i];
	bool possible = true;
	for (int i = 0; i < N; i++) {
		A[i] = minimize(A[i]);
		if (i > 0) {
			vector<ll> L = collect(A[i]);
			reverse(L.begin(), L.end());
			A[i] += leastAbove(L, 0, A[i - 1] - A[i]);
			if (A[i] < A[i - 1]) possible = false;
		}
	}

	if (!possible) cout << "impossible" << endl;
	else {
		cout << "possible" << endl;
		for (int i = 0; i < N; i++) cout << A[i] << endl;
	}

	return 0;
}
