#include <iostream>
#include <algorithm>
#include <cstring>

using namespace std;

typedef long long ll;

int dx[8] = { 1, 1, 0, -1, -1, -1, 0, 1 };
int dy[8] = { 0, 1, 1, 1, 0, -1, -1, -1 };

int DIR = 0;
int GOAL = 0;

struct Point {
	int x, y;
	int ID;
	int neighbor[8];
	ll count[8];
	bool operator<(const Point& r) const {
		if (DIR == -1) return ID < r.ID;
		if (dy[DIR] * x - dx[DIR] * y == dy[DIR] * r.x - dx[DIR] * r.y) return (dx[DIR] * x + dy[DIR] * y < dx[DIR] * r.x + dy[DIR] * r.y);
		return (dy[DIR] * x - dx[DIR] * y < dy[DIR] * r.x - dx[DIR] * r.y);
	}
};

int N;
Point P[5001];

ll countIt(int v, int d) {
	if (v == GOAL && d == 7) return 1;
	if (P[v].count[d] >= 0) return P[v].count[d];
	P[v].count[d] = 0;
	P[v].count[d] += (P[v].neighbor[d] == -1 ? 0 : countIt(P[v].neighbor[d], d));
	if (d < 7 && P[v].neighbor[d + 1] != -1) P[v].count[d] += countIt(P[v].neighbor[d + 1], d + 1);
	return P[v].count[d];
}

int main() {
	cin >> N;
	for (int i = 0; i < N; i++) {
		cin >> P[i].x >> P[i].y;
		P[i].ID = i;
		for (int j = 0; j < 8; j++) P[i].neighbor[j] = -1;
	}

	for (int k = 0; k < 8; k++) {
		DIR = k;
		sort(P, P + N);
		for (int i = 0; i < N - 1; i++) {
			if (dy[DIR] * P[i].x - dx[DIR] * P[i].y == dy[DIR] * P[i + 1].x - dx[DIR] * P[i + 1].y) P[i].neighbor[k] = P[i + 1].ID;
		}
	}
	DIR = -1;
	sort(P, P + N);

	ll C = 0;
	for (int i = 0; i < N; i++) {
		GOAL = i;
		if (P[i].neighbor[0] == -1) continue;
		for (int j = 0; j < N; j++) memset(P[j].count, -1, 8 * sizeof(ll));
		C += countIt(P[i].neighbor[0], 0);
	}

	cout << C << endl;

	return 0;
}
