#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <map>
#include <unordered_map>
#include <vector>
using namespace std;
using P = array<long long, 2>;
array<P, 8> ds{{{1, 0}, {1, 1}, {0, 1}, {-1, 1}, {-1, 0}, {-1, -1}, {0, -1}, {1, -1}}};
auto dot(const P& l, const P& r) { return l[0] * r[0] + l[1] * r[1]; }

int main() {
	int n;
	cin >> n;
	vector<P> ps(n);
	for(auto& p : ps) cin >> p[0] >> p[1];
	map<P, int> idx;
	for(int i = 0; i < n; ++i) idx[ps[i]] = i;

	vector<vector<long long>> v(n, vector<long long>(n, 0));
	for(int i = 0; i < n; ++i) v[i][i] = 1;

	for(auto d : ds) {
		P dp = {d[1], -d[0]};
		unordered_map<long long, vector<P>> off;
		for(auto p : ps) off[dot(dp, p)].push_back(p);
		for(auto& [k, ops] : off) {
			sort(begin(ops), end(ops),
			     [&](const auto& l, const auto& r) { return dot(d, l) < dot(d, r); });
			vector<long long> acc(n, 0);
			for(const auto& p : ops) {
				auto& v2 = v[idx[p]];
				long long t;
				for(int i = 0; i < n; ++i) t = v2[i], v2[i] = acc[i], acc[i] += t;
			}
		}
	}
	long long ans = 0;
	for(int i = 0; i < n; ++i) ans += v[i][i];
	cout << ans << endl;
}
