#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <map>
#include <unordered_map>
#include <vector>
using namespace std;
using P = array<long long, 2>;
array<P, 8> ds{{{1, 0}, {1, 1}, {0, 1}, {-1, 1}, {-1, 0}, {-1, -1}, {0, -1}, {1, -1}}};
auto dot(const P& l, const P& r) { return l[0] * r[0] + l[1] * r[1]; }

int main() {
	int n;
	cin >> n;
	vector<P> ps(n);
	for(auto& p : ps) cin >> p[0] >> p[1];
	map<P, int> idx;
	for(int i = 0; i < n; ++i) idx[ps[i]] = i;
	vector<vector<vector<int>>> lines;
	for(auto d : ds) {
		P dp = {d[1], -d[0]};
		unordered_map<long long, vector<P>> off;
		for(auto p : ps) off[dot(dp, p)].push_back(p);
		vector<vector<int>> v;
		for(auto& [k, ops] : off) {
			if(ops.size() <= 1) continue;
			sort(begin(ops), end(ops),
			     [&](const auto& l, const auto& r) { return dot(d, l) < dot(d, r); });
			v.emplace_back();
			for(const auto& p : ops) v.back().push_back(idx[p]);
		}
		lines.push_back(std::move(v));
	}
	vector<vector<long long>> v(n, vector<long long>(n, 0)), v2(n, vector<long long>(n, 0));
	for(int i = 0; i < n; ++i) v[i][i] = 1;
	for(const auto& dir_lines : lines) {
		for(auto& x : v2) x.assign(n, 0);
		for(const auto& line : dir_lines) {
			vector<long long> acc(n, 0);
			for(int j : line)
				for(int i = 0; i < n; ++i) v2[j][i] += acc[i], acc[i] += v[j][i];
		}
		swap(v, v2);
	}
	long long ans = 0;
	for(int i = 0; i < n; ++i) ans += v[i][i];
	cout << ans << endl;
}
