
#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

int main(){
  int n, m;
  cin >> n >> m;

  if( n%2 == 1){
    cout << n/2 << endl;
    return 0;
  }

  auto A = vector<vector<int>>(n, vector<int>());
  for(int i=0; i<m; i++){
    int a, b;
    cin >> a >> b;
    a--; b--;
    A[a].push_back(b);
    A[b].push_back(a);
  }

  auto visited = vector<bool>(n, false);
  auto component = vector<bool>(n, false);
  queue<int> q;
  q.push(0);
  visited[0] = true;
  component[0] = true;
  int V1 = 1; 
  int V2 = 0;
  while(!q.empty()){
    int v = q.front(); q.pop();
    for(auto & u : A[v]){
      if(!visited[u]){
        component[u] = !component[v];
        if(component[u]) V1++;
        else V2++;
        visited[u] = true;
        q.push(u);
      }
    }
  }

  if(V1 + V2 == n && V1%2 == 1 && V1*V2 == m){ 
    // complete bipartite graph with an odd number of nodes on both sides
    cout << (n/2 - 1) << endl;
  }
  else{
    cout << n/2 << endl;
  }

  return 0;

}
