#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

int n, m, k, sn, sm;
int j(int x, int y, int dx, int dy, int s) {
	int h = x + n * (y + m * (abs(dx) + sn * (abs(dy) + sm * s)));
	h *= 4;
	if(dx < 0) h += 1;
	if(dy < 0) h += 2;
	return h;
}
struct stat {
	int x, y, dx, dy, s;
	bool operator<(const stat& o) const { return s < o.s; }
};
int j(const stat& st) { return j(st.x, st.y, st.dx, st.dy, st.s); }

int bound(int x, int y, int dx, int dy) {
	assert(x >= 0 && y >= 0);
	int moves = 0;
	while(x > 0 || y > 0) dx = min(sn, dx + 1), dy = min(sm, dy + 1), x -= dx, y -= dy, moves++;
	return moves;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> m >> k;
	k += 1;
	vector<string> B(n);
	vector<int> x(k + 1), y(k + 1);
	for(int i = 0; i < n; ++i) {
		cin >> B[i];
		for(int j = 0; j < m; ++j)
			if(B[i][j] >= '0' && B[i][j] <= '9') {
				int v = B[i][j] - '0';
				x[v] = i, y[v] = j;
			}
	}
	x.push_back(x.back()), y.push_back(y.back());
	for(string& b : B) cin >> b;

	sn = 1, sm = 1;
	while(sn * (sn + 1) / 2 < n) ++sn;
	while(sm * (sm + 1) / 2 < m) ++sm;

	vector<int> tx(k + 2), ty(k + 2);
	for(int i = k; i >= 0; --i) {
		tx[i] = tx[i + 1] + abs(x[i] - x[i + 1]);
		ty[i] = ty[i + 1] + abs(y[i] - y[i + 1]);
	}

	int SZ = n * m * sn * sm * (k + 1) * 4;
	vector<int> dp(SZ, -1), est(SZ, -1);
	priority_queue<pair<int, stat>, vector<pair<int, stat>>, greater<pair<int, stat>>> pq;
	stat p0    = stat{x[0], y[0], 0, 0, 0};
	dp[j(p0)]  = 0;
	est[j(p0)] = bound(tx[0], ty[0], 0, 0);
	pq.push({est[j(p0)], p0});
	while(!pq.empty()) {
		stat u = pq.top().second;
		pq.pop();
		if(u.x == x[k] && u.y == y[k] && u.dx == 0 && u.dy == 0 && u.s == k) {
			cout << dp[j(u)] << endl;
			exit(0);
		}
		if(est[j(u)] == -2) continue;
		est[j(u)] = -2;
		if(u.dx > 0 && u.x + u.dx * (u.dx - 1) / 2 >= n) continue;
		if(u.dx < 0 && u.x - u.dx * (u.dx + 1) / 2 < 0) continue;
		if(u.dy > 0 && u.y + u.dy * (u.dy - 1) / 2 >= m) continue;
		if(u.dy < 0 && u.y - u.dy * (u.dy + 1) / 2 < 0) continue;
		for(int ddx = -1; ddx <= 1; ++ddx)
			for(int ddy = -1; ddy <= 1; ++ddy) {
				stat v = u;
				v.dx += ddx, v.dy += ddy;
				v.x += v.dx, v.y += v.dy;
				if(v.x < 0 || v.y < 0) continue;
				if(v.x >= n || v.y >= m) continue;
				if(B[v.x][v.y] == '#') continue;
				if(B[v.x][v.y] - '0' == v.s + 1) v.s++;

				int ourest =
				    dp[j(u)] + 1 +
				    bound(tx[v.s + 1] + abs(x[v.s + 1] - v.x), ty[v.s + 1] + abs(y[v.s + 1] - v.y),
				          x[v.s + 1] > v.x ? v.dx : -v.dx, y[v.s + 1] > v.y ? v.dy : -v.dy);

				if(est[j(v)] == -2 || (est[j(v)] >= 0 && est[j(v)] < ourest)) continue;
				est[j(v)] = ourest;
				dp[j(v)]  = dp[j(u)] + 1;
				pq.push({est[j(v)], v});
			}
	}
	cout << "impossible" << endl;
}
