#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

int n, m, k, sn, sm;
int j(int x, int y, int dx, int dy, int s) {
	int h = x + n * (y + m * (abs(dx) + sn * (abs(dy) + sm * s)));
	h *= 4;
	if(dx < 0) h += 1;
	if(dy < 0) h += 2;
	return h;
}
struct stat {
	int x, y, dx, dy, s;
};
int j(const stat& st) { return j(st.x, st.y, st.dx, st.dy, st.s); }

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> m >> k;
	k += 1;
	vector<string> B(n);
	vector<int> x(k + 1), y(k + 1);
	for(int i = 0; i < n; ++i) {
		cin >> B[i];
		for(int j = 0; j < m; ++j)
			if(B[i][j] >= '0' && B[i][j] <= '9') {
				int v = B[i][j] - '0';
				x[v] = i, y[v] = j;
			}
	}
	for(string& b : B) cin >> b;

	sn = 1, sm = 1;
	while(sn * (sn + 1) / 2 < n) ++sn;
	while(sm * (sm + 1) / 2 < m) ++sm;

	vector<int> dp(n * m * sn * sm * (k + 1) * 4, -1);
	queue<stat> q;
	q.push(stat{x[0], y[0], 0, 0, 0});
	dp[j(q.front())] = 0;
	while(!q.empty()) {
		stat u = q.front();
		q.pop();
		if(u.x == x[k] && u.y == y[k] && u.dx == 0 && u.dy == 0 && u.s == k) {
			cout << dp[j(u)] << endl;
			exit(0);
		}
		if(u.dx > 0 && u.x + u.dx * (u.dx - 1) / 2 >= n) continue;
		if(u.dx < 0 && u.x - u.dx * (u.dx + 1) / 2 < 0) continue;
		if(u.dy > 0 && u.y + u.dy * (u.dy - 1) / 2 >= m) continue;
		if(u.dy < 0 && u.y - u.dy * (u.dy + 1) / 2 < 0) continue;
		for(int ddx = -1; ddx <= 1; ++ddx)
			for(int ddy = -1; ddy <= 1; ++ddy) {
				stat v = u;
				v.dx += ddx, v.dy += ddy;
				v.x += v.dx, v.y += v.dy;
				if(v.x < 0 || v.y < 0) continue;
				if(v.x >= n || v.y >= m) continue;
				if(B[v.x][v.y] == '#') continue;
				if(B[v.x][v.y] - '0' == v.s + 1) v.s++;

				if(dp[j(v)] >= 0) continue;
				dp[j(v)] = dp[j(u)] + 1;
				q.push(v);
			}
	}
	cout << "impossible" << endl;
}
