// @EXPECTED_RESULTS@: WRONG_ANSWER,RUN_TIME_ERROR
#include <cstdio>
#include <iostream>
#include <vector>

using namespace std;

const int maxn = 2'000;
bool conn[maxn][maxn], vis[maxn] = {};

int n, sz[2] = {};

void dfs(int u, int col) {
	if(vis[u]) return;
	vis[u] = true;
	sz[col]++;
	for(int v = 0; v < n; v++) {
		if(conn[u][v]) dfs(v, 1 - col);
	}
}

void stop(int ans) {
	printf("%d\n", ans);
	exit(0);
}

int main() {
	int m;
	cin >> n >> m;
	if(n % 2 == 1) stop(n / 2);

	for(int i = 0; i < n; i++)
		for(int j = 0; j < n; j++) conn[i][j] = true;

	for(int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;

		conn[x][y] = conn[y][x] = false;
	}

	bool odd = false;
	for(int i = 0; i < n; i++) {
		sz[0] = sz[1] = 0;
		dfs(i, 0);
		if(sz[0] != sz[1]) {
			// by making some partitioning of left/right,
			// we may choose this component at the end, to make the number of
			// nodes on the left even, so the number of nodes on the right is
			// even as well.
			stop(n / 2);
		}
		if(sz[0] % 2 == 1 && sz[1] % 2 == 1) {
			// if the number of (odd left, odd right) is even, it cancels
			odd = !odd;
		}
	}
	stop(n / 2 - (odd ? 1 : 0));

	return 0;
}
