import java.util.Scanner;  // Import the Scanner class
import java.util.Vector;

class State {
	int x, y, vx, vy, p, dist;
	int[][] A = new int[55][55];
	int R, C, K;

	
	State(int x_, int y_, int vx_, int vy_, int p_, int dist_, int[][] A_, int R_, int C_, int K_){
		x = x_;
		y = y_;
		vx = vx_;
		vy = vy_;
		p = p_;
		dist = dist_;
		A = A_;
		R = R_;
		C = C_;
		K = K_;
	}

	public boolean isEnd() {
		return (A[x][y] == K+1 && vx == 0 && vy == 0 && p == K + 1);
	}
	public boolean isValid() {
		return (x >= 0 && y >= 0 && x < R&& y < C&& vx >= -10 && vy >= -10 && vx <= 10 && vy <= 10 && A[x][y] >= -1);
	}
}

class MichaelReadsKevinVector {
	public static void main(String[] args) {
		int[] dx = new int[] {0,1,1,0,-1,-1,-1,0,1};
		int[] dy = new int[] {0,0,1,1,1,0,-1,-1,-1};
		int[][] A = new int[55][55];
		boolean[][][][][] visited = new boolean[51][51][21][21][7];
		int startx = -1;
		int starty = -1;

		Vector<State> Q = new Vector<State>();
		
		Scanner input = new Scanner(System.in);  // Create a Scanner object
    	int R = input.nextInt();
    	int C = input.nextInt();
    	int K = input.nextInt();

		for (int i = 0; i < R; i++) {
			char[] str = input.next().toCharArray();
			for (int j = 0; j < C; j++) {
				if (str[j] == '.') A[i][j] = -1;
				else if (str[j] == '#') A[i][j] = -2;
				else A[i][j] = str[j] - '0';
				if (A[i][j] == 0) {
					startx = i; starty = j;
				}
			}
		}

		State start = new State(startx, starty, 0, 0, 0, 0, A, R, C, K);
		visited[startx][starty][10][10][0] = true;
		Q.add(start);

		for(int ki=0; ki<Q.size(); ki++){
			State E = Q.get(ki);
			if (E.isEnd()) {
				System.out.println(E.dist);
				return;
			}
			for (int i = 0; i < 9; i++) {
			 	State S = new State(E.x + E.vx + dx[i], E.y + E.vy + dy[i], E.vx + dx[i], E.vy + dy[i], E.p, E.dist + 1, A, R, C, K);
			 	if (S.isValid()) {
			 		if (A[S.x][S.y] == E.p + 1) S.p++;
			 		if (visited[S.x][S.y][S.vx + 10][S.vy + 10][S.p]) continue;
			 		visited[S.x][S.y][S.vx + 10][S.vy + 10][S.p] = true;
			 		Q.add(S);
			 	}
			}
		}
		System.out.println("impossible");
	}
}