#include<algorithm>
#include<cstring> // memset
#include<iostream>
#include<vector>

// Complexity: O(8 * n^2 log n)

using namespace std;
typedef long long ll;
typedef pair<int,int> ii;

const int maxn = 5000;
int n, x[maxn], y[maxn];

ll ways[9][maxn] = {};

ii ordering(int i, int d) {
	// >>, ^>, ^^, <^, <<, <v, vv, v>.

	// orthogonals:
	if (d==0) return ii( y[i],  x[i]);
	if (d==2) return ii(-x[i],  y[i]);
	if (d==4) return ii(-y[i], -x[i]);
	if (d==6) return ii( x[i], -y[i]);

	// diagonals:
	if (d==1) return ii(-x[i] + y[i],  x[i] + y[i]);
	if (d==3) return ii(-x[i] - y[i], -x[i] + y[i]);
	if (d==5) return ii( x[i] - y[i], -x[i] - y[i]);
	if (d==7) return ii( x[i] + y[i],  x[i] - y[i]);

	exit(1);
}

int main() {
	cin >> n;

	vector<int> order(n);
	for (int i=0; i<n; i++)
		cin >> x[i] >> y[i],
		order[i] = i;

	ll res = 0;
	for (int i=0; i<n; i++) {
		memset(ways, 0, sizeof ways);

		// init
		ways[0][i] = 1LL;

		// ->.
		for (int d=0; d < 8; d++) {
			sort(begin(order), end(order), [&] (int a, int b) -> bool { return ordering(a,d) < ordering(b,d); });
			int lst = -1;
			for (int j : order) {
				if (lst == -1 || ordering(lst, d).first != ordering(j, d).first)
					ways[d+1][j] = 0;
				else
					ways[d+1][j] = ways[d][lst] + ways[d+1][lst];
				lst = j;
			}
		}

		res += ways[8][i];
	}
	
	cout << res << endl;
}
