#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;

struct UnionFind {
	vector<int> par, rank, size;
	int c;
	UnionFind(int n) : par(n), rank(n, 0), size(n, 1), c(n) {
		for(int i = 0; i < n; ++i) par[i] = i;
	}
	int find(int i) { return (par[i] == i ? i : (par[i] = find(par[i]))); }
	bool same(int i, int j) { return find(i) == find(j); }
	int get_size(int i) { return size[find(i)]; }
	int count() { return c; }
	int merge(int i, int j) {
		if((i = find(i)) == (j = find(j)))
			return -1;
		else
			--c;
		if(rank[i] > rank[j]) swap(i, j);
		par[i] = j;
		size[j] += size[i];
		if(rank[i] == rank[j]) rank[j]++;
		return j;
	}
};

int main() {
	int n, m;
	cin >> n >> m;
	vector<pair<int, int>> edges(m);
	for(auto& [x, y] : edges) {
		cin >> x >> y, --x, --y;
		if(x > y) swap(x, y);
	}
	sort(begin(edges), end(edges));
	UnionFind uf(n);
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < i; ++j)
			if(auto it = lower_bound(begin(edges), end(edges), pair<int, int>{j, i});
			   it == edges.end() or *it != pair<int, int>{j, i}) {
				uf.merge(i, j);
			}

	if(uf.count() == 1)
		cout << n / 2 << endl;
	else
		cout << uf.get_size(0) / 2 + (n - uf.get_size(0)) / 2 << endl;
}
