#include <cassert>
#include <iostream>
#include <vector>
using namespace std;

const int mod = 1'000'000'007;

int run(int h, int l) {
	// l = number of agile persons
	if (l == 0) {
		// edge case:
		return 1;
	}

	int ans = 0;

	// dp [ length of diagonal ][ nr of light people ] = # of ways.
	vector<vector<int>> dp(h+1, vector<int>(l+1, 0));

	for (int n = 1; n <= min(h, l); n++) {
		dp[n][n] = 1;
	}

	for (int i = h-1; i >= 0; i--) {
		for (int n = i+1; n >= 1; n--) {
			// dp[n][l]:
			// number of ways to use diagonals i+1,...,h with
			// - length(i+1)=n,
			// - # light persons = l
			// ans = (ans + dp[n][l]) % mod;
			ans += dp[n][l];
		}

		for (int s = 1; s <= l; s++) {
			for (int n = i; n >= 1; n--) {
				// dp[n][s]: number of ways to use diagonals i+1,..., h with
				// - length(i+1) >= n,
				// - # light persons = s.
				// dp[n][s] = (dp[n][s] + dp[n+1][s]) % mod;
				dp[n][s] += dp[n+1][s];
			}
		}

		for (int n = i; n >= 1; n--) {
			for (int s = l; s >= n; s--) {
				dp[n][s] = dp[n][s - n];
			}
			for (int s = min(l+1, n); s--; ) {
				dp[n][s] = 0;
			}
			// dp[n][s]: number of ways to use diagonals i,..., h with
			// - length(i) = n,
			// - # light persons = s.
		}
	}

	// WA: no intermediate modding!
	ans %= mod;
	if (ans < 0) ans += mod;

	return ans;
}

int main() {
	int h, s;
	cin >> h >> s;
	int ans = run(h, h*(h+1)/2 - s);
	cout << ans << endl;

	return 0;
}
