import sys

N, M = [int(x) for x in input().split()]

adj = [[] for _ in range(N)]

for _ in range(M):
    a, b = [int(x) for x in input().split()]
    a -= 1
    b -= 1
    adj[a].append(b)
    adj[b].append(a)

# The only situations where you cannot make N // 2 pairs, is where the graph
# is complete bipartite on two components of odd size.

# That means there must either be exactly one degree count, which is equal to
# N//2 (and odd), or two odd degree counts, which add up to N exactly.
vals = list(set(len(x) for x in adj))

if ((len(vals) == 1 and vals[0] % 2 == 1 and 2*vals[0] == N) or 
        (len(vals) == 2 and vals[0] % 2 == 1)):
    print((N-1)//2)
else:
    print(N//2)
