#include <array>
#include <iostream>
#include <queue>
using namespace std;

constexpr int NM = 100;
constexpr int VM = 9;
array<array<bool, 100>, 100> board;
array<array<array<array<array<bool, 2 * VM + 1>, 2 * VM + 1>, 100>, 100>, 7> done;

struct P {
	int r, c;
};
bool operator==(const P& l, const P& r) { return l.r == r.r and l.c == r.c; }
struct S {
	P p, v;
	int i;
};
bool operator==(const S& l, const S& r) { return l.p == r.p and l.v == r.v and l.i == r.i; }
struct SD {
	S s;
	int dist;
};
P operator+(const P& l, const P& r) { return {l.r + r.r, l.c + r.c}; }

int main() {
	for(auto& x : done)
		for(auto& y : x)
			for(auto& z : y)
				for(auto& a : z) a.fill(false);
	int n, m, k;
	cin >> n >> m >> k;
	k += 1;
	vector<P> ps(k + 10);
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < m; ++j) {
			char c;
			cin >> c;
			if(c == '#') {
				board[i][j] = false;
				continue;
			}

			board[i][j] = true;
			if(c != '.') { ps[c - '0'] = {i, j}; }
		}

	queue<SD> q;
	q.push({{ps.front(), {0, 0}, 0}, 0});
	S t{ps[k], {0, 0}, k};

	while(!q.empty()) {
		const auto& [s, d] = q.front();
		for(int dx : {-1, 0, 1})
			for(int dy : {-1, 0, 1}) {
				SD sd{{s.p + s.v + P{dx, dy}, s.v + P{dx, dy}, s.i}, d + 1};
				auto& s = sd.s;
				if(s.i < k and s.p == ps[s.i + 1]) s.i += 1;
				if(s.p.r < 0 or s.p.c < 0 or s.p.r >= n or s.p.c >= m) continue;
				if(abs(s.v.r) > VM or abs(s.v.c) > VM) continue;
				if(!board[s.p.r][s.p.c]) continue;
				bool& d = done[s.i][s.p.r][s.p.c][s.v.r + VM][s.v.c + VM];
				if(d) continue;
				d = true;

				if(s.p == t.p) {
					cout << sd.dist << endl;
					return 0;
				}

				q.push(sd);
			}

		q.pop();
	}

	cout << "impossible\n";
}
