#include <algorithm>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <vector>
using namespace std;
using vvi       = vector<vector<int>>;
constexpr int D = 20;
int dig(char c) { return (c == '9' ? 6 : int(c - '0')); }

bool wrong(const vector<int>& L, const vector<int>& R) {
	assert(L.size() == R.size());
	int n = (int)L.size();
	for(int j = n - 1; j >= 0; --j)
		if(L[j] > R[j])
			return true;
		else if(L[j] < R[j])
			return false;
	return false;
}

bool solve(int n, vvi& S) {
	for(int i = 0; i + 1 < n; ++i) {
		while(wrong(S[i], S[i + 1])) {
			bool any = false;
			for(int j = 0; !any && j < D; ++j) {
				if(S[i + 1][j] == 6) S[i + 1][j] = 9, any = true;
			}
			if(!any) return false;
		}
	}
	return true;
}

int main() {
	int n;
	cin >> n;
	vvi S(n);
	for(int i = 0; i < n; ++i) {
		string v;
		cin >> v;
		for(auto it = v.rbegin(); it != v.rend(); ++it) S[i].push_back(dig(*it));
		while(S[i].size() < (size_t)D) S[i].push_back(0);
	}

	if(!solve(n, S))
		cout << "impossible" << endl;
	else {
		cout << "possible" << endl;
		for(int i = 0; i < n; ++i) {
			while(S[i].back() == 0) S[i].pop_back();
			for(auto it = S[i].rbegin(); it != S[i].rend(); ++it) cout << *it;
			cout << '\n';
		}
		cout << flush;
	}
}
